﻿# $author = T. Butz, 
# $version = summit.2014.07.01
# $url = 'www.thorsten-butz.de'; $twitter = $adn = '@thorstenbutz'

Import-Module Hyper-V # OPTIONAL 

$vmhost = '.'
$timestamp = Get-Date -UFormat '%y%m%d'
$vm = $timestamp + '_' + (Read-Host 'VM name')
$cpucount = 2					
$startupram = 4GB
$vhdzsize = 300GB
$switch = 'HV_Private2'
$iso1 = 'C:\depot\iso\HydrationCM2012R2_ADATUM_DE.iso'
 
New-VM `
-ComputerName:$vmhost `
–Name:$vm `
-MemoryStartupBytes:$startupram `
-NewVHDPath:"$vm.vhdx" `
-NewvhdSizeBytes:$vhdzsize

Set-VM `
-ComputerName:$vmhost `
–name:$vm `
-ProcessorCount:$cpucount `
-DynamicMemory 

Set-VMBios `
-ComputerName:$vmhost `
-vmname:$vm `
-StartupOrder:@("IDE", "CD", "Floppy", "LegacyNetworkAdapter")

Connect-VMNetworkAdapter `
-ComputerName:$vmhost `
-VMName:$vm `
–SwitchName:$switch

if ($iso1) {
Set-VMDvdDrive `
-ComputerName:$vmhost `
–VMName:$vm `
-Path:$iso1 
}

Start-VM -ComputerName $vmhost -VMName $vm