# $author = T. Butz, 
# $version = summit.2014.07.01
# $url = 'www.thorsten-butz.de'; $twitter = $adn = '@thorstenbutz'

# OSCDIMG:   http://technet.microsoft.com/en-us/library/cc749036(v=ws.10).aspx

Param
    (      
        
        [Parameter(Mandatory=$false, Position=1)]
        [string]$newprefix = "van",
        [Parameter(Mandatory=$true, Position=2)]
        [string]$startfolder = '.'
    )

if ($startfolder -notlike "*unattended*"){ Read-Host 'Did you choose the right folder to start? (ENTER to continue)' }

# PATH TO THE ISO CREATOR
$oscdimg = 'c:\windows\system32\oscdimg.exe'

if (!(Test-Path $oscdimg)) { "OSCDIMG not found!" ; exit }

# .\oscdimg.exe -l"TheLabel" -m -u2 "sourcefolder" isofile.iso ## UDF Filesystem
# .\oscdimg.exe -l"TheLabel" -n -m  "sourcefolder" isofile.iso ## ISO Filesystem

# Getting folders
$folders = @(Get-ChildItem $startfolder -Directory -Recurse | 
  Where-Object { $_.name -like "*-*"})

foreach ($folder in $folders) {

 [string]$template  = $folder.Name.split()[0]  # Ignores everything beyond a space
 [string]$vm        = $folder.Name.split()[0] -replace 'template',$newprefix
 [string]$newfolder = ($folder.Parent).Fullname  + '\' + $vm 
 [string]$parent    = $folder.psparentpath -replace 'Microsoft.PowerShell.Core\\FileSystem::'
 [string]$auto      = "$newfolder\autounattend.xml"
 # [string]$iso       = $parent + '\' + "$vm.iso"     # Put the ISO file into the template folder
 [string]$iso       = $startfolder + '\' + "$vm.iso"  # Put the ISO file into the starting folder

 if ($template -like "template-*") {

  if (Test-Path $newfolder) {"Path $newfolder exists .." ; exit } else { 
      mkdir $newfolder | Out-Null
      Copy-Item "$($folder.Fullname)\*" $newfolder -Recurse 
  }

   Write-Host -ForegroundColor yellow $vm '<=' $template
   [xml]$content = Get-Content $auto
   $component = $content.unattend.settings.component | ? {$_.computername -like $template }
   $component.computername = $vm
   $content.Save($auto)
   &$oscdimg -l"UnattendedISO" -n -m $newfolder $iso | Out-Null 
   Remove-Item $newfolder -Recurse  
 }
 else {
   write-host -ForegroundColor yellow $vm 
   &$oscdimg -l"UnattendedISO" -n -m $folder.fullname $iso | Out-Null 
 }
}
