"Starting setup1.ps1 ..."
sleep 5

# Enable WSMan in Workgroup environment
# Set-Item WSMan:\localhost\Client\TrustedHosts * -Force

## MULTIPLE SUBNETS
switch -wildcard ($(hostname.exe))
{
    'sea*'  {$n = 101}
    'van*'  {$n = 111}
    'den*'  {$n = 121}
    'per*'  {$n = 131}
    'bri*'  {$n = 141}
    'lis*'  {$n = 151}
    'bon*'  {$n = 161}
    'lim*'  {$n = 171}
    Default {$n = Get-Random -Minimum 21 -Maximum 99 }
}
## SINGLE SUBNET
$n = 1

$prefix = "192.168.0."
$ip4 = $prefix + $n 
$nics = gip etherne*
$defgw4 = $prefix + "254"
$pl = "24"
$sm = "255.255.255.0"
# $dns = $prefix+ + "101"
$dns = "8.8.8.8"
$domain = (hostname.exe).substring(0,3)
$domain += '.contoso.com'

$nics[0] | New-NetIPAddress -IPAddress $ip4 -DefaultGateway $defgw4 -AddressFamily IPv4 -PrefixLength $pl
$nics[0] | Set-DnsClientServerAddress -ServerAddresses $dns
# Rename-NetAdapter -newname CorporateLAN


Import-Module ServerManager

# Install/Configure DHCP-Server
Install-WindowsFeature dhcp -IncludeManagementTools
Import-Module dhcpserver 

Add-DhcpServerv4Scope -Name LabScope -StartRange ($prefix + "41") -EndRange ($prefix + "99") -SubnetMask $sm -LeaseDuration 1:00:00:00
Set-DhcpServerv4OptionValue -OptionId 3 -Value ($prefix + "254") -ScopeId ($prefix + "0") -Force
Set-DhcpServerv4OptionValue -OptionId 6 -Value ($prefix + "1") -ScopeId ($prefix + "0") -Force
Set-DhcpServerv4OptionValue -OptionId 15 -Value $domain -ScopeId ($prefix + "0")

# Install/Configure ADDS
Install-WindowsFeature AD-Domain-Services -IncludeManagementTools


[string]$ver = (gwmi win32_operatingsystem).version

if ($ver -like "6.2*") {
  $forestmode = "Win2003"
  $domainmode = "Win2003"
}
elseif ($ver -like "6.3*") {
  $forestmode = "Win2008"
  $domainmode = "Win2008"
}
else { break }

$password = ConvertTo-SecureString 'Pa$$w0rd' -AsPlainText -Force
Install-ADDSForest -SkipPreChecks -DomainName $domain -SafeModeAdministratorPassword $password `
-ForestMode:$forestmode -DomainMode $domainmode -Force